//------------------------------------------------------------------------------
//
//  npxml.h
//
//  ANTz application based on NPE
//
//  Created by Shane Saxon on 3/13/11.
//  Copyright Saxon Digital 2010-2011. All rights reserved.
//
//------------------------------------------------------------------------------
#ifndef NPXML_H_
#define NPXML_H_


#include <stdio.h>
#include "../../npdata.h"


//------------------------------------------------------------------------------
void npInitXML (void* dataRef);
void npCloseXML (void* dataRef);

// these functions wrap the standard C file methods on Linux, MSW and OSX
// opens or creates the file in the specified mode "rb+" read/write binary..
FILE* npOpenXML (const char* fileName, const char* mode, void* dataRef);

FILE* npXMLNew (const char* fileName, const char* mode, void* dataRef);

FILE* npXMLDialog (const char* fileName, int dialogType, void* dataRef);

// if not saved then opens SaveAs dialog before reseting app
void npCloseXML (void* dataRef);

// wrappers for fread(), fwrite() and rewind()
//void npReadFile (void* writeBuffer, int wordSize, int size, void* dataRef);
int npReadXML (void* readBuffer, int elementSize, int elementCount, 
				 FILE* file, void* dataRef);
int npWriteXML (const void* str, int wordSize, int size, FILE* file, void* dataRef);

// 
void npSaveXML (FILE* file, void* dataRef);

void npImportXML (FILE* file, int type, void* dataRef);
void npExportXML (FILE* file, void* dataRef);

// file and directory management
void npGetAttribXML (int size, void* dataRef);
void npSetAttribXML (int size, void* dataRef);

void npTestXML (void* fileName, int wordSize, int size, void* dataRef);


#endif